<template>
  <v-container>
    <v-row>
      <v-col cols="5" />
      <v-col cols="7">
        <h1 v-text="title" />
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-text-field label="First Name*" v-model="user.first_name" :disabled="statusProgress" required />
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-text-field label="Last Name" v-model="user.last_name"  :disabled="statusProgress" required />
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-text-field label="Username*" v-model="user.username" :disabled="statusProgress" required />
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-text-field label="Email*" v-model="user.email" :disabled="statusProgress" required />
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-text-field label="Telegram ID*" v-model="user.telegram_id" :disabled="statusProgress" required />
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-spacer></v-spacer>
        <v-btn color="blue darken-1" text @click="doChangePassword(user.id)" :disabled="statusProgress">Change Password</v-btn>
        <v-btn color="blue darken-1" text @click="doUpdate" :disabled="statusProgress">Update Profile</v-btn>
      </v-col>
    </v-row>
    <UserResetForm ref="dlgReset" />
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import userService from "../service/UserService";
import UserResetForm from "../components/UserResetPassword"

export default {
  name: "UserProfile",
  components: {
    UserResetForm,
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      roles: [],
      userRole: [],
      user: {
        id: null,
        first_name: null,
        last_name: null,
        username: null,
        password: null,
        email: null,
        telegram_id: null,
        enabled: false,
        account_non_expired: false,
        credentials_non_expired: false,
        account_non_locked: false,
        roles: [],
      },
      title: 'Profile User',
      statusProgress: false,
    }
  },
  methods: {
    doChangePassword(id) {
      let title = "Change Password User"
      this.$refs.dlgReset.doEdit(id, title, true)
    },
    async doUpdate() {
      if (!this.validation()) {
        return
      }
      let data = this.user
      this.statusProgress = true
      await userService.update(data.id, data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              this.user = res.data.data
              await window._VMA.$emit('REFRESH_TOKEN')
            }
            this.dialog = false
            console.log(res.data.message)
          })
          .catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg(`ERROR EXCEPTION`)
          })
      this.statusProgress = false
    },
    async retrieveUser(username) {
      this.statusProgress = true
      await userService.getByUsername(username)
          .then(res => {
            let status = res.data.status
            if (status === 'SUCCESS') {
              this.user = res.data.data
            } else {
              this.$refs.dlgMsg.doOpenMsg(res.data.message)
            }
          }).catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg(`ERROR EXCEPTION`)
      })
      this.statusProgress = false
    },
    validation() {
      if (this.user.first_name == null || this.user.first_name === '') {
        this.$refs.dlgMsg.doOpenMsg("First Name Harus Diisi")
        return false
      } else if (this.user.username == null || this.user.username === '') {
        this.$refs.dlgMsg.doOpenMsg("Username Harus Diisi")
        return false
      } else if (this.user.email == null || this.user.email === '') {
        this.$refs.dlgMsg.doOpenMsg("Email Harus Diisi")
        return false
      } else if (this.user.telegram_id == null || this.user.telegram_id === '') {
        this.$refs.dlgMsg.doOpenMsg("Telegram ID Harus Diisi")
        return false
      }
      return true
    },
  },
  mounted() {
    this.retrieveUser(this.$route.params.username)
  },
}
</script>

<style scoped>

</style>